<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="7" :lg="7" :xl="7">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchUsuariosPerfil"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
              <v-progress-linear
                :active="isLoadingUsuarios"
                :indeterminate="isLoadingUsuarios"
                absolute
                bottom
                color="primary"
              />
            </v-toolbar>
            <v-list
              height="300"
              max-height="300"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader style="position : relative;">
                USUARIOS FIJOS CON EL PERFIL
                <v-btn
                  style="top:10px;"
                  color="primary"
                  fab
                  dark
                  small
                  absolute
                  top
                  right
                  @click="getUsuariosFijosPerfil"
                >
                  <v-icon color="white">mdi-sync</v-icon>
                </v-btn>
              </v-subheader>
              <v-list-item-group
                v-model="selectedUsuariosPerfil"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedUsuariosPerfil"
                  :key="indexItem"
                >
                  <template v-slot:default="{}">
                    <v-list-item-avatar>
                      <v-icon large>mdi-account-circle-outline</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title>
                        <router-link
                          class="text-decoration-underline"
                          :to="toUsuario(item)"
                        >
                          {{ item.nombreUsuario }}
                        </router-link>
                      </v-list-item-title>
                      <v-list-item-subtitle
                        v-text="item.numeroEmpleado"
                      ></v-list-item-subtitle>
                    </v-list-item-content>
                  </template>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-UsuariosFijos",
  props: ["perfilIn"],
  data() {
    return {
      isLoadingUsuarios: false,
      searchUsuariosPerfil: null,
      selectedUsuariosPerfil: null,
      usuariosPerfil: [],
      perfil: null,
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchedUsuariosPerfil() {
      let tempData = this.usuariosPerfil;
      if (this.searchUsuariosPerfil != "" && this.searchUsuariosPerfil) {
        tempData = tempData.filter((item) => {
          return JSON.stringify(item)
            .toUpperCase()
            .includes(this.searchUsuariosPerfil.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.usuario.nombre.toLowerCase();
          let fb = b.usuario.nombre.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    toUsuario(usuario) {
      return {
        name: "accesos_usuarios_edicion",
        params: {
          usuario: this.serviceCommons.objectToBase64(usuario),
        },
      };
    },
    getUsuariosFijosPerfil() {
      this.isLoadingUsuarios = true;
      axios(
        "/accesos/sistema/usuarios/v1/perfiles/" +
          this.perfil.idPerfil +
          "/fijos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.usuariosPerfil = data.resultado.usuarios;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.usuariosPerfil = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingUsuarios = false;
        });
    },
  },
  created() {
    this.perfil = this.perfilIn;
    this.getUsuariosFijosPerfil();
  },
};
</script>
